/*
 * SmartTable
 *  Copyright (C) 1999,2000  ASAMI, Tomoharu (tasami@ibm.net)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.SmartTable;

import java.io.*;
import java.net.URL;
import org.w3c.dom.*;
import jp.gr.java_conf.jaba2.util.D2Array;
import jp.gr.java_conf.jaba2.j2fw.generator.*;
import jp.gr.java_conf.jaba2.j2fw.translator.*;
import jp.gr.java_conf.jaba2.util.*;
import jp.gr.java_conf.jaba2.xml.*;

/**
 * HTMLTableGenerator
 *
 * @since   Aug.  8, 1999
 * @version Jan. 17, 2000
 * @author  ASAMI, Tomoharu (tasami@ibm.net)
 */
public class HTMLTableGenerator extends AbstractSmartTableGenerator {
    public String getID() {
	return ("htmltable");
    }

    public String getName() {
	return ("HTMLTable Generator");
    }

    public GeneratorResult generate(IGeneratorParameter param) {
	String encoding = model_.getOutputEncoding();
	Metadata metadata = model_.getMetadataOut();
	D2Array d2 = model_.getData();
	Document doc = metadata.d2Array2HTMLTable(d2);
	GeneratorResult result = new GeneratorResult();
	result.addArtifact(
	    model_.getProject() + ".xml",
	    UXML.doc2String4Print(doc, encoding),
	    encoding
	);
	return (result);
    }
}
