package jp.gr.java_conf.jaba2.awt;

import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

/**
 * ExitWhenWindowClosing is window listener to exit in case of
 * receiving the WindowClosing event.
 * This object is used to register to a Frame as WindowListener.
 *
 * <p>
 * Created: Mar. 25, 1998
 * @version Mar. 25, 1998
 * @author  ASAMI, Tomoharu (tasami@ibm.net)
 */

public class ExitWhenWindowClosing extends WindowAdapter {
    // WindowAdapter
    /**
     * Terminate JavaVM because the WindowClosing event is received.
     *
     * @param evt  
     */
    public void windowClosing(WindowEvent evt) {
	System.exit(0);
    }
}
