/*
 * The JabaJaba class library
 *  Copyright (C) 1997-2000  ASAMI, Tomoharu (asami@zeomtech.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.dombus.config;

import jp.gr.java_conf.jaba2.dombus.configRelaxer.*;

/**
 * DOMBusConfigFileFactory
 *
 * @since   Mar. 28, 2000
 * @version Apr. 11, 2000
 * @author  ASAMI, Tomoharu (asami@zeomtech.com)
 */
public class DOMBusConfigFileFactory extends DefaultConfigFileFactory {
    public CConfig createCConfig() {
	throw (new InternalError());
    }

    public CComponentSet createCComponentSet() {
        return (new CComponentSet());
    }

    public CSlot createCSlot() {
        return (new CSlot());
    }

    public CComponent createCComponent() {
        return (new CComponent());
    }

    public CGuard createCGuard() {
        return (new DOMBusConfigGuard());
    }

    public COrGuardPredicate createCOrGuardPredicate() {
        return (new DOMBusOrGuardPredicate());
    }

    public CAndGuardPredicate createCAndGuardPredicate() {
        return (new DOMBusAndGuardPredicate());
    }

    public CEventGuardPredicate createCEventGuardPredicate() {
        return (new DOMBusEventGuardPredicate());
    }

    public CClass createCClass() {
        return (new CClass());
    }

    public CPost createCPost() {
	return (new DOMBusPost());
    }
}

