/*
 * The JabaJaba class library
 *  Copyright (C) 1997-1999  ASAMI, Tomoharu (tasami@ibm.net)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.j2fw.generator;

import java.util.*;
import java.io.*;
import jp.gr.java_conf.jaba2.io.UFile;

/**
 * GeneratorArtifact
 *
 * @since   Apr. 29, 1999
 * @version Sep.  5, 1999
 * @author  ASAMI, Tomoharu (tasami@ibm.net)
 */
public abstract class GeneratorArtifact {
    public String name_;

    protected GeneratorArtifact(String name) {
	name_ = name;
    }

    public String getName() {
	return (name_);
    }

    public File makeFile() throws IOException {
	return (makeFile(new File(".")));
    }

    public File makeFile(File dir) throws IOException {
	File file = new File(dir, name_);
	UFile.createFile(file, getBytes());
	return (file);
    }

    public void outputStream(OutputStream out) throws IOException {
	out.write(getBytes());
	out.flush();
    }

    public abstract byte[] getBytes() throws IOException;
}
