package jp.gr.java_conf.jaba2.text.generator;

import java.io.File;
import java.net.URL;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;

/**
 * SimpleGeneratorModel
 *
 * @since   Feb.  8, 1998
 * @version Aug.  5, 1998
 * @author  ASAMI, Tomoharu (tasami@ibm.net)
 */
public class SimpleGeneratorModel extends AbstractGeneratorModel {
    protected Map map_ = new HashMap();

    public SimpleGeneratorModel() {
    }

    public SimpleGeneratorModel(String resource) {
	_setPrototypeFromResource(resource);
    }

    public SimpleGeneratorModel(File file) {
	_setPrototypeFromFile(file);
    }

    public SimpleGeneratorModel(URL url) {
	_setPrototypeFromURL(url);
    }

    // Model
    public String[] getTags() {
	String[] strings = new String[map_.size()];
	Iterator iter = map_.keySet().iterator();
	int i = 0;
	while (iter.hasNext()) {
	    strings[i++] = (String)iter.next();
	}
	return (strings);
    }

    // Model
    public String getSubstituteString(String tag) {
	return ((String)map_.get(tag));
    }

    public void setMap(String tag, String value) {
	map_.put(tag, value);
    }

    public void setMap(String[][] map) {
	for (int i = 0;i < map.length;i++) {
	    map_.put(map[i][0], map[i][1]);
	}
    }
}
