/*
 * The JabaJaba class library
 *  Copyright (C) 1997-2000  ASAMI, Tomoharu (asami@zeomtech.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.tmodel;

import java.util.*;
import java.sql.*;

/**
 * TTypeVARCHAR
 *
 * @since   Feb. 18, 2000
 * @version Dec. 16, 2000
 * @author  ASAMI, Tomoharu (asami@zeomtech.com)
 */
public class TTypeVARCHAR implements ITType, ITSizable {
    private int size_;

    public TTypeVARCHAR(int size) {
	size_ = size;
    }

    public String getName() {
	return ("VARCHAR");
    }

    public String getDDLName() {
	return ("VARCHAR(" + size_ + ")");
    }

    public int getSQLType() {
	return (Types.VARCHAR);
    }

    public Class getJavaType() {
	return (Boolean.class);
    }

    public Object string2Object(String string) {
	throw (new UnsupportedOperationException());
    }

    public String object2String(Object object) {
	return (object.toString());
    }

    // Sizable
    public int getSize() {
	return (size_);
    }
}
