/*
 * The JabaJaba class library
 *  Copyright (C) 1997-2000  ASAMI, Tomoharu (tasami@ibm.net)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.vfs.ftp;

import java.io.*;
import com.oroinc.net.*;

/**
 * LogCommandListener
 *
 * @since   Jan. 16, 2000
 * @version Jan. 16, 2000
 * @author  ASAMI, Tomoharu (tasami@ibm.net)
 */
public class LogCommandListener implements ProtocolCommandListener {
    private PrintWriter out_;

    public LogCommandListener() {
	out_ = new PrintWriter(System.out);
    }

    public void protocolCommandSent(ProtocolCommandEvent event) {
        out_.print(event.getMessage());
	out_.flush();
    }

    public void protocolReplyReceived(ProtocolCommandEvent event) {
	out_.print(event.getMessage());
	out_.flush();
    }
}
