/*
 * The JabaJaba class library
 *  Copyright (C) 1997-2000  ASAMI, Tomoharu (asami@zeomtech.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.xml.relax.expanded;

import java.util.*;
import org.w3c.dom.*;
import jp.gr.java_conf.jaba2.xml.relax.cooked.*;

/**
 * EVisitorBase
 *
 * @since   Dec.  1, 2000
 * @version Dec. 10, 2000
 * @author  ASAMI, Tomoharu (asami@zeomtech.com)
 */
public class EVisitorBase implements IEVisitor {
    public boolean enter(EElementNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(EElementSlotNode node) {
	return (enter((EElementNode)node));
    }

    public boolean enter(EContentNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(EElementRefNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(EContentRefNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(EElementSlot node) {
	return (enter((ENode)node));
    }

    public boolean enter(EAttributeSlot node) {
	return (enter((ENode)node));
    }

    public boolean enter(ESequenceNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(EChoiceNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(EMixedNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(EExternalRefNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(EExternalRoleRefNode node) {
	return (enter((ENode)node));
    }

    public boolean enter(ENode node) {
	return (true);
    }

    public void leave(EElementNode node) {
	leave((ENode)node);
    }

    public void leave(EElementSlotNode node) {
	leave((EElementNode)node);
    }

    public void leave(EContentNode node) {
	leave((ENode)node);
    }

    public void leave(EElementRefNode node) {
	leave((ENode)node);
    }

    public void leave(EContentRefNode node) {
	leave((ENode)node);
    }

    public void leave(EElementSlot node) {
	leave((ENode)node);
    }

    public void leave(EAttributeSlot node) {
	leave((ENode)node);
    }

    public void leave(ESequenceNode node) {
	leave((ENode)node);
    }

    public void leave(EChoiceNode node) {
	leave((ENode)node);
    }

    public void leave(EMixedNode node) {
	leave((ENode)node);
    }

    public void leave(EExternalRefNode node) {
	leave((ENode)node);
    }

    public void leave(EExternalRoleRefNode node) {
	leave((ENode)node);
    }

    public void leave(ENode node) {
    }
}
