/*
 * The JabaJaba class library
 *  Copyright (C) 1997-2001  ASAMI, Tomoharu (asami@zeomtech.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.xml.relax.raw;

import org.w3c.dom.*;
import jp.gr.java_conf.jaba2.xml.*;
import jp.gr.java_conf.jaba2.xml.datatype.*;
import jp.gr.java_conf.jaba2.text.UString;

/**
 * RAnyOtherElement
 *
 * @since   Feb. 22, 2001
 * @version Aug. 29, 2001
 * @author  ASAMI, Tomoharu (asami@zeomtech.com)
 */
public class RAnyOtherElement extends RNode {
    private String occurs_;
    private String[] includeNamespaces_;
    private String[] excludeNamespaces_;

    public RAnyOtherElement(Element element) {
	super(element);
	occurs_ = UString.checkNull(element.getAttribute("occurs"));
	includeNamespaces_ = 
	    UElement.getAttributeAsNMTOKENS(element, "includeNamespace");
	excludeNamespaces_ = 
	    UElement.getAttributeAsNMTOKENS(element, "excludeNamespace");
    }

    public final String getOccurs() {
	return (occurs_);
    }

    public final String[] getIncludeNamespaces() {
	return (includeNamespaces_);
    }

    public final String[] getExcludeNamespaces() {
	return (excludeNamespaces_);
    }
}
