/*
 * The JabaJaba class library
 *  Copyright (C) 1997-2001  ASAMI, Tomoharu (asami@zeomtech.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.xml.relax.raw;

import org.w3c.dom.*;
import jp.gr.java_conf.jaba2.xml.datatype.*;
import jp.gr.java_conf.jaba2.text.UString;

/**
 * RElementRule
 *
 * @since   Dec. 17, 1999
 * @version Feb. 22, 2001
 * @author  ASAMI, Tomoharu (asami@zeomtech.com)
 */
public class RElementRule extends RRule {
    private String pattern_;
    private String type_;

    protected RElementRule(Element element) {
	super(element);
	pattern_ = UString.checkNull(element.getAttribute("role"));
	if (pattern_ == null) {
	    pattern_ = UString.checkNull(element.getAttribute("pred"));
	}
	type_ = UString.checkNull(element.getAttribute("type"));
    }

    public final void setPattern(String pattern) {
	pattern_ = pattern;
    }

    public final String getPattern() {
	return (pattern_);
    }

    public final String getType() {
	return (type_);
    }
}
