/*
 * The JabaJaba class library
 *  Copyright (C) 1997-2000  ASAMI, Tomoharu (asami@zeomtech.com)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.xml.sax;

import org.xml.sax.*;
import jp.gr.java_conf.jaba2.text.UString;

/**
 * SimpleErrorHandler
 *
 * @since   Feb. 26, 2000
 * @version May. 28, 2001
 * @author  ASAMI, Tomoharu (asami@zeomtech.com)
 */
public class SimpleErrorHandler extends HandlerBase {
    public void error(SAXParseException e) {
	System.err.print("[Error] ");
	System.err.println(USAX.getMessage(e));
    }

    public void fatalError(SAXParseException e) {
	System.err.print("[Fatal Error] ");
	System.err.println(USAX.getMessage(e));
    }

    public void warning(SAXParseException e) {
	System.err.print("[Warning] ");
	System.err.println(USAX.getMessage(e));
    }
}
