/*
 * The JabaJaba class library
 *  Copyright (C) 1997-1999  ASAMI, Tomoharu (tasami@ibm.net)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.xml.schema;

import org.w3c.dom.*;
import jp.gr.java_conf.jaba2.xml.*;

/**
 * ContentModel
 *
 * @since   Aug. 31, 1999
 * @version Aug. 31, 1999
 * @author  ASAMI, Tomoharu (tasami@ibm.net)
 */
public abstract class ContentModel implements Constants {
    public ContentModel(Element root) {
    }

    public static ContentModel create(Element root) {
	String tagName = root.getTagName();
	if ("any".equals(tagName)) {
	    return (new AnyContentModel(root));
	} else if ("empty".equals(tagName)) {
	    return (new EmptyContentModel(root));
	} else if ("mixed".equals(tagName)) {
	    return (new MixedContentModel(root));
	} else {
	    throw (new InternalError()); // XXX
	}
    }
}
