/*
 * The JabaJaba class library
 *  Copyright (C) 1997-1999  ASAMI, Tomoharu (tasami@ibm.net)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

package jp.gr.java_conf.jaba2.xml.schema;

import java.net.URL;
import java.net.MalformedURLException;
import org.w3c.dom.*;
import jp.gr.java_conf.jaba2.xml.*;

/**
 * SchemaRef
 *
 * @since   Aug. 17, 1999
 * @version Aug. 18, 1999
 * @author  ASAMI, Tomoharu (tasami@ibm.net)
 */
public class SchemaRef {
    protected String abbrev_;
    protected URL name_;

    public SchemaRef(String abbrev) {
	abbrev_ = abbrev;
    }

    public SchemaRef(URL name) {
	name_ = name;
    }

    public SchemaRef(String abbrev, URL name) {
	abbrev_ = abbrev;
	name_ = name;
    }

    public static SchemaRef createByAttributes(Element root) {
	try {
	    SmartElement se = new SmartElement(root);
	    String abbrev = se.getAttributeAsString("schemaAbbrev");
	    URL name = se.getAttributeAsURL("schemaName");
	    if (abbrev == null && name == null) {
		return (null);
	    }
	    return (new SchemaRef(abbrev, name));
	} catch (MalformedURLException e) {
	    throw (new InternalError()); // XXX
	}
    }
}
